-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                       
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 2007 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/tracks/oa21208.sql, tbsm_base, tbsm_base31e
-- SID: 1.3
-- Date Modified: 07/06/26 08:53:31
--
-- For APAR OA21208.
-- Script to fix case of CLOB_C records.
--
SET NOCOUNT ON

USE Object
GO

DECLARE @id INT,
  @ptr BINARY(16),
  @longName NVARCHAR(512),
  @startPos INT,
  @endPos INT,
  @len INT,
  @newText NVARCHAR(1024),
  @msg NVARCHAR(1024),
  @err int

SET @err=0

DECLARE OA21218_Cursor CURSOR LOCAL FAST_FORWARD 
FOR 
SELECT  id, 
  textptr(_Data),
  _Long_Name,
  CHARINDEX('<fullname>',_Data),
  CHARINDEX('</fullname>',_Data)
FROM CLOB_C
WHERE _Data LIKE '%<workspace>%'

OPEN OA21218_Cursor

FETCH NEXT FROM OA21218_Cursor INTO @id, @ptr, @longName, @startPos, @endPos

WHILE ( @@fetch_status = 0 AND @err = 0 )
BEGIN
  IF ((ISNULL(@startPos,0) = 0) OR (ISNULL(@endPos,0) = 0) OR (@endPos-@startPos<0))
  BEGIN
    SELECT @msg = 'Warning: Could not find <fullname> for ' + @longName + ' in _Data. No change made.'
    RAISERROR ('%s',3,1,@msg) WITH NOWAIT
  END
  ELSE
  BEGIN
    SELECT @len = @endPos - @startPos + 11 -- Add on 11 for length of </fullname>
    SELECT @newText = '<fullname>' + @longName + '</fullname>'

    SELECT @msg = 'Updating CLOB_C with ' + @newText + '.'
    RAISERROR ('%s',0,1,@msg) WITH NOWAIT

    SET @startPos = @startPos - 1
    UPDATETEXT CLOB_C._Data @ptr @startPos @len @newText

    SET @err = @@error
    IF @err <> 0
    BEGIN
      SELECT @msg = 'Error updating _Data with ' + @newText + 'for id ' + convert(nvarchar(10),@id) + '.'
      RAISERROR ('%s',11,1,@msg) WITH NOWAIT
    END
  END
  FETCH NEXT FROM OA21218_Cursor INTO @id, @ptr, @longName, @startPos, @endPos
END

CLOSE OA21218_Cursor
DEALLOCATE OA21218_Cursor

GO
